import os,sys
import dataset

import vasp
import void

database_file='job_database.db'
database=dataset.connect('sqlite:///'+database_file)
num_entries=database['data'].__len__()

print("Number of database entries: {}".format(num_entries))
check = input("Are you sure you want to clean error directories? (y/n)")
if not check =='y':
    sys.exit()
start = int(input("Enter the start index."))
end = int(input("Enter the end index."))

for i in range(start,end+1):
    job_record=database['data'].find_one(id=i)

    #database entry --> class instance
    if job_record['program'] == "vasp6.2" or job_record['program'] == "vasp6.3" or job_record['program'] == "vasp6.3-beef":
        job = vasp.Vasp(job_record, database_file)
    elif job_record['program'] == "void":
        job = void.Void(job_record, database_file)
    else:
        NameError("Unknown program ({})".format(job_record['program']))
        continue

    #get status
    status = job.get_status()
    print("{:5d}: {}".format(i, status))

    if status in ['error', 'prepared','scf_not_converged']:
        job.delete()

    status = job.get_status()
    job_record = job.get_job_record()
    print("      --> {}".format(status))

    #updtate the database
    database.begin()
    try:
        database['data'].update(job_record, ['id'])
        database.commit()
    except:
        database.rollback()
        print(job_record)
        print("WARINING: db.rollback")


