import os
import dataset

import vasp
import void

database_file=input("Input name of sqlite database: ")
#database_file='job_database.db'
database=dataset.connect('sqlite:///'+database_file)
num_entries=database['data'].__len__()

print("Number of database entries: {}".format(num_entries))
recreate = input("Do you want to recreate the input? (y/n)")
act = input("Do you want to take actions (i.e., not only gather results)? (y/n)")
start = int(input("Enter the start index."))
end = int(input("Enter the end index."))

for i in range(start,end+1):
    job_record=database['data'].find_one(id=i)

    #database entry --> class instance
    if job_record['program'] == "vasp6.2" or job_record['program'] == "vasp6.3.0" or job_record['program'] == "vasp6.3.2" or job_record['program'] == "vasp6.3.0-beef":
        job = vasp.Vasp(job_record, database_file)
    elif job_record['program'] == "void":
        job = void.Void(job_record, database_file)
    else:
        NameError("Unknown program ({})".format(job_record['program']))
        continue

    #get status
    if not recreate == 'y':
        status = job.get_status()
        print("{:5d}: {}".format(i, status))
    else: #if only recreating input: use stored status
        status = job_record['status']

    #take appropriate actions
    print(act, recreate) 
    if act == 'y':
        if status == 'prepared' and not recreate == 'y':
            job.run()
        elif status == 'new' and not recreate == 'y':
            job.write_input()
        elif recreate == 'y':
            print(status)
            if status == 'done': #only recreate directories for wich calculations were actually completed
                job.write_input(recreate=True)
                job.run(recreate=True)

    #update the status and get the updated the job_record
    if not recreate == 'y':#don't updata anything if only recreating input.
        status = job.get_status()
        job_record = job.get_job_record()
        print("      --> {}".format(status))

        #updtate the database
        database.begin()
        try:
            database['data'].update(job_record, ['id'])
            database.commit()
        except:
            database.rollback()
            print(job_record)
            print("WARINING: db.rollback")


